<?php
/**
 * zogan - PHP template engine for XML
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * @author Haruki Setoyama <haruki@planewave.org>
 * @copyright Copyright &copy; 2003-2004, Haruki SETOYAMA <haruki@planewave.org>
 * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @version 0.1- $Id: zogan.templatefile.local.php,v 1.2 2004/10/19 03:55:40 haruki Exp $
 * @link http://phpoot.sourceforge.jp/zogan/
 * @package zogan
 * @subpackage template
 */
/**
 * ZOGAN template file abstraction for local file
 *
 * @package zogan
 * @subpackage template
 */
class zogan_templatefile_local extends zogan_templatefile {

    var $_file;
    var $_file_get_contents;

    function zogan_templatefile_local($file)
    {
        $this->_file = $file;
        $this->_file_get_contents = function_exists('file_get_contents');
    }

    function getUpdateTime()
    {
        return filemtime($this->_file);
    }

    function getBasename()
    {
        return basename($this->_file);
    }

    function getTemplate()
    {
        if ($this->_file_get_contents) {
            $content = file_get_contents($this->_file);
        } else {
            $fp = fopen($this->_file, 'rb');
            if ($fp === false) {
                return $this->raiseError(
                    "Failed to open a file '".$this->_file."' for reading. ",
                    ZOGAN_ERR_TEMPLATE);
            }
            $content = fread($fp, filesize($this->_file));
        }
        if ($content === false) {
            return $this->raiseError(
                "Failed to get content from a file '".$this->_file."'. ",
                ZOGAN_ERR_TEMPLATE);
        }
        return $content;
    }

    function changeBasename($file)
    {
        $this->_file = dirname($this->_file).'/'.$file;
    }

    function getEncoding()
    {
		// TODO: encoding estimation? 
        return 'utf-8';
    }
}

?>